// Generated by CoffeeScript 1.9.2
(function() {
  var EVENT_NAME, EventEmitter, Panel, React, Tab, TabFactory;

  React = require("react");

  EventEmitter = require("eventemitter3");

  Tab = require("./components/tab");

  Panel = require("./components/panel");

  EVENT_NAME = "react-tab-factory:tab-changed";

  TabFactory = (function() {
    function TabFactory() {
      this._emitter = new EventEmitter();
      this._tabIndex = 0;
      this._panelIndex = 0;
      this._selectedIndex = 0;
      this.tabClassNames = {
        normal: "",
        active: "active"
      };
      this.panelClassName = "";
    }

    TabFactory.prototype.addListener = function(listener) {
      return this._emitter.on(EVENT_NAME, listener);
    };

    TabFactory.prototype.removeListener = function(listener) {
      return this._emitter.removeListener(EVENT_NAME, listener);
    };

    TabFactory.prototype.notify = function() {
      return this._emitter.emit(EVENT_NAME, this._selectedIndex);
    };

    TabFactory.prototype.select = function(index) {
      this._selectedIndex = index;
      return this.notify();
    };

    TabFactory.prototype.getSelectedIndex = function() {
      return this._selectedIndex;
    };

    TabFactory.prototype.createTab = function(handler, selected) {
      var currentIndex;
      currentIndex = this._tabIndex;
      if (selected) {
        this._selectedIndex = currentIndex;
      }
      this._tabIndex++;
      return React.createElement(Tab, {
        "index": currentIndex,
        "classNames": this.tabClassNames,
        "factory": this,
        "handler": handler
      });
    };

    TabFactory.prototype.createPanel = function(handler) {
      var currentIndex;
      currentIndex = this._panelIndex;
      this._panelIndex++;
      return React.createElement(Panel, {
        "index": currentIndex,
        "className": this.panelClassName,
        "factory": this,
        "handler": handler
      });
    };

    return TabFactory;

  })();

  module.exports = TabFactory;

}).call(this);
